
DECLARE
  v_exists INTEGER;
BEGIN
 SELECT count(*) 
    INTO v_exists 
    FROM user_tables 
    WHERE UPPER(Table_Name)='LAYERDATA_RP';
 IF v_exists=0 THEN
  
  EXECUTE IMMEDIATE 'CREATE TABLE LayerData_RP 
   (	
    /* */
  	ID NUMBER(10,0) NOT NULL, 
	LAYERREF NUMBER(10,0) NOT NULL, 
	LAYERVERSION NUMBER(10,0), 
	FACIALACCCLS NUMBER(10,0), 
  	SENDERID NUMBER(10,0), 
	SENDERRECORDID NUMBER(10,0), 
  	SENDERID_FORCHECK NUMBER(10,0),
	RVERSION NUMBER(10,0), 
	CREATEDATE DATE NOT NULL, 
	CREATERUSER VARCHAR2(30) NOT NULL, 
	UPDATEDATE DATE NOT NULL, 
	UPDATERUSER VARCHAR2(30) NOT NULL, 
	TASKREF NUMBER(10,0), 
  "PRODUCTREF" NUMBER(10,0), 
	OWNERUSER NUMBER(10,0) DEFAULT null NOT NULL, 
	EXECUTERUSER NUMBER(10,0) DEFAULT null NOT NULL, 
	UPDATESTATUS NUMBER(10,0), 
  UPDATEDRECORDINDEX NUMBER(10,0), 
	UPDATEGROUPINDEX NUMBER(10,0), 
  ACCEPTDATE NUMBER, 
	REJECTDATE NUMBER, 
	REJECTCAUSE VARCHAR2(255), 
	NATURALKEY VARCHAR2(255), 
	DOCSTATEREF NUMBER(10,0), 
	CRYPTOSTATUS NUMBER(10,0), 
	LOCKSTATUS NUMBER(2,0), 
	LOCKINFO VARCHAR2(255), 
	DATEOPEN NUMBER, 
	DATECLOSE NUMBER, 
	BUDGETREF NUMBER(10,0), 
  
  /*  */
  AssemblyNum NUMBER(10,0),
  CaptionID NUMBER(10,0),
  AmendmentNum NUMBER(10,0),
  RequestNum NUMBER(10,0),
  RecordNum NUMBER(10,0),
  OperationID NUMBER(10,0),
  OperationType NUMBER(10,0),
  ChangeType NUMBER(10,0),
  DocCode NUMBER(10,0),
  
  /*  */
	INTFIELD00 NUMBER(10,0), 
	INTFIELD01 NUMBER(10,0), 
	INTFIELD02 NUMBER(10,0), 
	INTFIELD03 NUMBER(10,0), 
	INTFIELD04 NUMBER(10,0), 
  INTFIELD05 NUMBER(10,0), 
	INTFIELD06 NUMBER(10,0), 
  INTFIELD07 NUMBER(10,0), 
  INTFIELD08 NUMBER(10,0), 
  INTFIELD09 NUMBER(10,0), 
  INTFIELD10 NUMBER(10,0), 
  INTFIELD11 NUMBER(10,0), 
  INTFIELD12 NUMBER(10,0), 
  INTFIELD13 NUMBER(10,0), 
  INTFIELD14 NUMBER(10,0), 
  INTFIELD15 NUMBER(10,0), 
	DATEFIELD00 NUMBER, 
	DATEFIELD01 NUMBER, 
	DATEFIELD02 NUMBER, 
  DATEFIELD03 NUMBER, 
  DATEFIELD04 NUMBER, 
  DATEFIELD05 NUMBER, 
	STRFIELD00 VARCHAR2(1024 BYTE), 
	STRFIELD01 VARCHAR2(1024 BYTE), 
	STRFIELD02 VARCHAR2(1024 BYTE), 
	STRFIELD03 VARCHAR2(1024 BYTE), 
	STRFIELD04 VARCHAR2(1024 BYTE), 
  STRFIELD05 VARCHAR2(1024 BYTE), 
  STRFIELD06 VARCHAR2(1024 BYTE), 
  STRFIELD07 VARCHAR2(1024 BYTE), 
  STRFIELD08 VARCHAR2(1024 BYTE), 
	STRFIELD09 VARCHAR2(1024 BYTE), 
	STRFIELD10 VARCHAR2(1024 BYTE), 
	STRFIELD11 VARCHAR2(1024 BYTE), 
	STRFIELD12 VARCHAR2(1024 BYTE), 
  STRFIELD13 VARCHAR2(1024 BYTE), 
  STRFIELD14 VARCHAR2(1024 BYTE), 
  STRFIELD15 VARCHAR2(1024 BYTE),
  STRFIELD16 VARCHAR2(1024 BYTE), 
	STRFIELD17 VARCHAR2(1024 BYTE), 
	STRFIELD18 VARCHAR2(1024 BYTE), 
  STRFIELD19 VARCHAR2(1024 BYTE), 
  STRFIELD20 VARCHAR2(1024 BYTE), 
  FLOATFIELD00 NUMBER(15,2), 
	FLOATFIELD01 NUMBER(15,2), 
	FLOATFIELD02 NUMBER(15,2), 
	FLOATFIELD03 NUMBER(15,2), 
	FLOATFIELD04 NUMBER(15,2), 
  FLOATFIELD05 NUMBER(15,2),

	 CHECK ((ID<=2147483647)AND(ID>-2147483648)), 
	 CHECK ((LayerRef<=2147483647)AND(LayerRef>-2147483648)), 
	 CHECK ((LayerVersion<=2147483647)AND(LayerVersion>-2147483648)), 
	 CHECK ((FacialAccCls<=2147483647)AND(FacialAccCls>-2147483648)), 
	 CHECK ((IntField00<=2147483647)AND(IntField00>-2147483648)), 
	 CHECK ((IntField01<=2147483647)AND(IntField01>-2147483648)), 
	 CHECK ((IntField02<=2147483647)AND(IntField02>-2147483648)), 
	 CHECK ((IntField03<=2147483647)AND(IntField03>-2147483648)), 
	 CHECK ((IntField04<=2147483647)AND(IntField04>-2147483648)), 
	 CHECK ((IntField05<=2147483647)AND(IntField05>-2147483648)), 
	 CHECK ((IntField06<=2147483647)AND(IntField06>-2147483648)), 
	 CHECK ((IntField07<=2147483647)AND(IntField07>-2147483648)),
   CHECK ((IntField08<=2147483647)AND(IntField08>-2147483648)), 
	 CHECK ((IntField09<=2147483647)AND(IntField09>-2147483648)), 
	 CHECK ((IntField10<=2147483647)AND(IntField10>-2147483648)), 
	 CHECK ((IntField11<=2147483647)AND(IntField11>-2147483648)), 
	 CHECK ((IntField12<=2147483647)AND(IntField12>-2147483648)),
   CHECK ((IntField13<=2147483647)AND(IntField13>-2147483648)), 
	 CHECK ((IntField14<=2147483647)AND(IntField14>-2147483648)), 
	 CHECK ((IntField15<=2147483647)AND(IntField15>-2147483648)),
   
   CHECK ((AssemblyNum<=2147483647)AND(AssemblyNum>-2147483648)),   
   CHECK ((CaptionID<=2147483647)AND(CaptionID>-2147483648)),  
   CHECK ((AmendmentNum<=2147483647)AND(AmendmentNum>-2147483648)),
   CHECK ((RequestNum<=2147483647)AND(RequestNum>-2147483648)),
   CHECK ((OperationID<=2147483647)AND(OperationID>-2147483648)),
   CHECK ((OperationType<=2147483647)AND(OperationType>-2147483648)),
   CHECK ((ChangeType<=2147483647)AND(ChangeType>-2147483648)),
   CHECK ((DocCode<=2147483647)AND(DocCode>-2147483648)),
  
	 CHECK ((SenderID<=2147483647)AND(SenderID>-2147483648)), 
	 CHECK ((SenderRecordID<=2147483647)AND(SenderRecordID>-2147483648)), 
	 CHECK ((Rversion<=2147483647)AND(Rversion>-2147483648)), 
	 CONSTRAINT "PK_LD_RP" PRIMARY KEY ("ID"), 
	 CHECK ((TASKREF<=2147483647)AND(TASKREF>-2147483648)), 
   CHECK ((ProductRef<=2147483647) and (ProductRef>=-2147483648)),
	 CHECK ((OwnerUser<=2147483647)AND(OwnerUser>-2147483648)), 
	 CHECK ((ExecuterUser<=2147483647)AND(ExecuterUser>-2147483648)), 
	 CHECK ((UpdateStatus<=2147483647) and (UpdateStatus>=-2147483648)), 
	 CHECK ((UpdatedRecordIndex<=2147483647) and (UpdatedRecordIndex>=-2147483648)), 
	 CHECK ((UpdateGroupIndex<=2147483647) and (UpdateGroupIndex>=-2147483648)), 
	 CHECK ((SENDERID_FORCHECK<=2147483647) and (SENDERID_FORCHECK>=-2147483648)), 
	 CHECK ((BUDGETREF<=2147483647)AND(BUDGETREF>-2147483648)), 
	 CONSTRAINT "FK_LD_RP_LAYERREF" FOREIGN KEY ("LAYERREF")
	  REFERENCES "LAYERS" ("ID"), 
	 CONSTRAINT "FK_LD_RP_TASKREF" FOREIGN KEY ("TASKREF")
	  REFERENCES "LAYERTASKS" ("ID"), 
	 CONSTRAINT "FK_LD_RP_OWNER" FOREIGN KEY ("OWNERUSER")
	  REFERENCES "TB_DBUSERS" ("ID"), 
	 CONSTRAINT "FK_LD_RP_EXECUTER" FOREIGN KEY ("EXECUTERUSER")
	  REFERENCES "TB_DBUSERS" ("ID"), 
	 CONSTRAINT "FK_LD_RP_FACIALACCCLS" FOREIGN KEY ("FACIALACCCLS")
	  REFERENCES "TB_FACIALACC_CLS" ("ID")
  )';

  EXECUTE IMMEDIATE 'CREATE INDEX FK_LD_RP_EXECUTER ON LayerData_RP (EXECUTERUSER)';

  EXECUTE IMMEDIATE 'CREATE INDEX FK_LD_RP_FACIALACCCLS ON LayerData_RP (FACIALACCCLS)';

  EXECUTE IMMEDIATE 'CREATE INDEX FK_LD_RP_LAYERREF ON LayerData_RP (LAYERREF)';

  EXECUTE IMMEDIATE 'CREATE INDEX FK_LD_RP_OWNER ON LayerData_RP (OWNERUSER)';

  EXECUTE IMMEDIATE 'CREATE INDEX FK_LD_RP_TASKREF ON LayerData_RP (TASKREF)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RP_ADATE ON LayerData_RP (ACCEPTDATE)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RP_BUDGETREF ON LayerData_RP (BUDGETREF)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RP_LAYER ON LayerData_RP (LAYERVERSION, LAYERREF)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RP_RDATE ON LayerData_RP (REJECTDATE)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RP_STATE ON LayerData_RP (DOCSTATEREF)';


  /*   */
  
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RP_ASN ON LayerData_RP (AssemblyNum)';
  
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RP_CAP ON LayerData_RP (CaptionID)';
  
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RP_OPID ON LayerData_RP (OperationID)';
  
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RP_OPTYPE ON LayerData_RP (OperationType)';
  
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RP_CHNGTYPE ON LayerData_RP (ChangeType)';
  
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RP_DOC ON LayerData_RP (DocCode)';
  
  EXECUTE IMMEDIATE 'COMMIT WORK';
  
 END IF;
END;
/
  

CREATE OR REPLACE TRIGGER "TR_LD_RP_AD" after delete ON LayerData_RP FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AD_500
-- Create 05.09.2005
-- - - - - - - - - - - - -

    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (174, :old.ID, SYSDATE);
    
end;

/
ALTER TRIGGER "TR_LD_RP_AD" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_RP_AI" after insert ON LayerData_RP FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AI_500
-- Create 05.09.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 174) and (RecordID = :new.ID);
  
end;

/
ALTER TRIGGER "TR_LD_RP_AI" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_RP_AU" after update ON LayerData_RP FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AU_500
-- Create 05.09.2005
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (174, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=174) and (RecordId=:new.ID);
  end if;
  
end;

/
ALTER TRIGGER "TR_LD_RP_AU" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_RP_BI" 
 BEFORE
  INSERT
 ON LayerData_RP
REFERENCING NEW AS NEW OLD AS OLD
 FOR EACH ROW
declare
  fac NUMBER(10);
begin

-- - - - - - - - - - - - -
-- BI_(0)
-- Create 05.09.2005
-- Last Update 22.05.2009
-- - - - - - - - - - - - -

    if (:new.id is null) then select g_Shared.nextval into :new.Id from DUAL; end if;
    if (:new.LayerVersion is null) then :new.LayerVersion := 0; end if;
    if (:new.ExecuterUser is null) then :new.ExecuterUser := :new.OwnerUser; end if;
    if ((:new.FacialAccCls is null) and (:new.TaskRef is not null)) then
      BEGIN
        select FacialAccCls into fac from LayerTasks where ID = :new.TaskRef;
        :new.FacialAccCls := fac;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    end if;
    if (:new.TaskRef is not null) then
      BEGIN
        select LayerVersion, DocStateRef, AcceptDate, RejectDate, OwnerUser, ExecuterUser
          into :new.LayerVersion, :new.DocStateRef, :new.AcceptDate, :new.RejectDate,
          :new.OwnerUser, :new.ExecuterUser
        from LayerTasks where ID = :new.TaskRef;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          :new.LayerVersion := NULL;
          :new.DocStateRef := NULL;
          :new.AcceptDate := NULL;
          :new.RejectDate := NULL;
          :new.OwnerUser := NULL;
          :new.ExecuterUser := NULL;
      END;  
    end if;
    
-- - - - - - - - - - - - -
-- BI_500
-- Create 05.09.2005
-- - - - - - - - - - - - -
  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;
end;

/
ALTER TRIGGER "TR_LD_RP_BI" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_RP_BU" 
 BEFORE
  UPDATE
 ON LayerData_RP
REFERENCING NEW AS NEW OLD AS OLD
 FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- BU_(0)
-- Create 05.09.2005
-- - - - - - - - - - - - -

    if (:new.LayerVersion is null) then :new.LayerVersion := 0; end if;
    if (:new.ExecuterUser is null) then :new.ExecuterUser := :new.OwnerUser; end if;
    
-- - - - - - - - - - - - -
-- BU_700
-- Create 05.09.2005
-- - - - - - - - - - - - -

  if (:new.RVersion is null) then
    :new.RVersion := 1;
  elsif ((:new.RVersion = -1) and (:old.RVersion <> -1)) then
    :new.RVersion := :old.RVersion;
  else
    :new.RVersion := :old.RVersion+1;
  end if;

end;

/
ALTER TRIGGER "TR_LD_RP_BU" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_RP_BU_500" before update on LayerData_RP for each row
begin
-- - - - - - - - - - - - -
-- BU_500
-- - - - - - - - - - - - -
    :new.UpdateDate := SYSDATE;
    :new.UpdaterUser := User;
end;

/
ALTER TRIGGER "TR_LD_RP_BU_500" ENABLE;
/

GRANT SELECT, INSERT, UPDATE, DELETE ON LayerData_RP TO PUBLIC;
/

COMMIT WORK;
/




  

